<script setup lang="ts">
import { ref, Ref, onUpdated } from "vue";

const data: string[] = ["a", "b", "c"];

const noBar: Ref<boolean> = ref(false);
const scroll: Ref<boolean> = ref(false);
const items: Ref<string[]> = ref(data);

// FAILED ATTEMPT OF CLEARING OLDER ITEMS TO MAKE
// IT MORE PERFORMANT ON THE LONG TERM
//
// onUpdated(() => {
//   const limit: number = data.length * 30;
//   const older: number = data.length * 10;
//   if (items.value.length > limit) {
//     const temp: string[] = items.value.slice(older);
//     items.value = temp;
//   }
// });

const applyClasses = (scroll: boolean, noBar: boolean): string => {
  !scroll ? "snap" : "";
  const arr: string[] = [!scroll ? "snap" : "", noBar ? "nobar" : ""];
  return arr.join(" ");
};

const scrollFn = (evt: Event) => {
  if (scroll.value === false) {
    items.value = items.value.concat(data);
    // quick&dirty trick to avoid triggering the events 50 times for every scroll
    setTimeout(() => {
      scroll.value = false;
    }, 250);
    scroll.value = true;
  }
};
</script>

<template>
  <p>
    <input type="checkbox" :checked="noBar" @change="noBar = !noBar" />
    disable/enable scrollbar
  </p>
  <ul @scroll="scrollFn" :class="applyClasses(scroll, noBar)">
    <li v-for="(item, index) in items" :key="index" :data-index="index">
      {{ item }} - {{ index }}
    </li>
  </ul>
</template>

<style scoped>
ul {
  margin: 0;
  padding: 0;
  border: 1px solid red;
  display: flex;
  gap: 20px;
  width: 290px;
  overflow-x: scroll;
  user-select: none;
}

ul.nobar::-webkit-scrollbar {
  display: none;
}

ul.snap {
  scroll-snap-type: x mandatory;
}

ul.snap li {
  scroll-snap-align: center;
}

li {
  list-style: none;
  min-width: 250px;
  padding: 0;
  margin: 0;
  height: 350px;
  line-height: 100px;
  color: white;
}

li:nth-child(3n + 1) {
  background-color: green;
  background-image: url(https://picsum.photos/id/237/250/350);
}
li:nth-child(3n + 2) {
  background-color: blue;
  background-image: url(https://picsum.photos/id/1023/250/350);
}
li:nth-child(3n + 3) {
  background-color: purple;
  background-image: url(https://picsum.photos/id/1055/250/350);
}
</style>
